[kuangbin带你飞]专题一 简单搜索-F - Prime Path POJ - 3126

Prime Path

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

 

6 7 0

题解:

        题目给出两个四位且第一位不为0的正整素数数,要求是让我每次改一位的数字,把第一个素数其改成第二个素数,但是题目还有一个要求,就是再改动过程中出现四位数必须也都是素数。如果存在输出最小操作数,否则输出Impossible.
         很明显的的宽搜题目,每次改一位。就是判断素数会有更好的方法,比如打表,或新看到的米勒罗宾判定法。
#include <iostream>
#include <cstring>
#include <queue>

using namespace std;

int S,E;

bool isP(int x){
    int t = 2;
    for (;t*t <= x;t ++){
        if (x%t == 0)return false;
    }
    return true;
}
bool IsPrime[10007];
bool vis[10007];

struct Node {
    int va,step;
    Node(int va = 0,int step = 0):va(va),step(step){}
};

int main()
{
    ios::sync_with_stdio(false);

    for (int i = 1000;i <= 9999;i ++){
        IsPrime[i] = isP(i);
    }

    int T;
    cin >> T;
    while (T --){
        cin >> S >> E;
        memset(vis,0,sizeof(vis));

        queue<Node> qu;
        qu.push(S);
        vis[S] = 1;

        int k,st;
        int flag = 0;
        while (!qu.empty()){
            k = qu.front().va;
            st = qu.front().step;
            qu.pop();

            if (k == E){
                flag = 1;
                break;
            }

            for (int i = 0;i < 10;i ++){
                int t = k/10*10+i;
                if (vis[t] || !IsPrime[t])continue;
                qu.push(Node(t,st+1));
                vis[t] = 1;
            }

            for (int i = 0;i < 10;i ++){
                int t = k/100*100+i*10+k%10;
                if (vis[t] || !IsPrime[t])continue;
                qu.push(Node(t,st+1));
                vis[t] = 1;
            }

            for (int i = 0;i < 10;i ++){
                int t = k/1000*1000+i*100+k%100;
                if (vis[t] || !IsPrime[t])continue;
                qu.push(Node(t,st+1));
                vis[t] = 1;
            }

            for (int i = 0;i < 10;i ++){
                int t = k%1000+i*1000;
                if (vis[t] || !IsPrime[t])continue;
                qu.push(Node(t,st+1));
                vis[t] = 1;
            }
        }
        if (flag)cout << st << endl;
        else cout << "Impossible" << endl;
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
并查集是一种常用的数据结构,用于管理一个不相交集合的数据。在并查集中,每个元素都有一个父节点指向它所属的集合的代表元素。通过查找和合并操作,可以判断两个元素是否属于同一个集合,并将它们合并到同一个集合中。 在解决某些问题时,可以使用并查集进行优化。例如,在区间查询中,可以通过优化并查集的查询过程,快速找到第一个符合条件的点。 对于拆边(destroy)操作,一般的并查集无法直接实现这个功能。但是可以通过一个巧妙的方法来解决。首先,记录下所有不会被拆除的边,然后按照逆序处理这些指令。遇到拆边操作时,将该边重新加入并查集中即可。 在实现并查集时,虽然它是一种树形结构,但只需要使用数组就可以实现。可以通过将每个元素的父节点记录在数组中,来表示元素之间的关系。通过路径压缩和按秩合并等优化策略,可以提高并查集的效率。<span class="em">1</span><span class="em">2</span><span class="em">3</span> #### 引用[.reference_title] - *1* *2* [「kuangbin专题五并查集专题题解](https://blog.csdn.net/weixin_51216553/article/details/121643742)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] - *3* [并查集(详细解释+完整C语言代码)](https://blog.csdn.net/weixin_54186646/article/details/124477838)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v93^chatsearchT3_2"}}] [.reference_item style="max-width: 50%"] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值